package com.gps.model;

import java.util.Map;

import android.webkit.WebView;

public class ThreadUtility  {

	private WebView webview ;
	private Map<String,String> map;
	
	public Map<String, String> getMap() {
		return map;
	}

	public void setMap(Map<String, String> map) {
		this.map = map;
	}

	private String result;

	
	public String getResult() {
		return result;
	}

	public void setResult(String result) {
		this.result = result;
	}

	public void loadUrl(WebView webview1, final String path) {
		webview = webview1;		
		
		webview.post( new Runnable(){public void run(){
			webview.loadUrl(path);
		}});
	}
	
	public void loadUrlWithParam(WebView webview1, final String function, final String param) {
		webview = webview1;
		
		webview.post( new Runnable(){public void run(){
			webview.loadUrl("javascript:"+function+"('"+param+"')");
		}});
	}
	
	public void loadUrlByBtnSubmitInscriptionClick(WebView webview1, Map<String,String> param) {
		webview = webview1;
		map = param;
		
		webview.post( new Runnable(){public void run(){
		    webview.loadUrl("javascript:onSuccesFromInscription('"+map.get("activate")+"','"
					+map.get("phone")+"','"
					+map.get("email")+"','" //etat du mail
					+map.get("emailValue")+"')"); // mail
		}});
	}
	
	public void loadUrlOnCalculateUsers(WebView webview1, String myResult) {
		webview = webview1;
		result = myResult;
		
		webview.post( new Runnable(){public void run(){
			webview.loadUrl("javascript:printUsersOnMap('"+result+"')");
		}});
	}
	
	public void loadPrintRoadOfMeeting(WebView webView1, final String json, final String jsonMeeting, final String email){
		webview = webView1;
		
		webview.post( new Runnable(){public void run(){
			webview.loadUrl(("javascript:loadPrintRoadOfMeeting('"+json+"','"+jsonMeeting+"','"+email+"')"));
		}});
	}
	
	public void loadPrintUsersOnMap(WebView webView1, final String json,final String lati_centre, final String longi_centre){
		webview = webView1;
		
		webview.post( new Runnable(){public void run(){
			webview.loadUrl(("javascript:printUsersOnMap('"+json+"','"+lati_centre+"','"+longi_centre+"')"));
		}});
	}
	
	public void loadUpdateMarkersOnMap(WebView webView1, final String json, final String jsonMeeting, final String email){
		webview = webView1;
		
		webview.post( new Runnable(){public void run(){
			webview.loadUrl(("javascript:updateMarkersOnMap('"+json+"','"+jsonMeeting+"','"+email+"')"));
		}});
	}


}
