package com.gps.projetisima;

/*/
 * Un thread qui se lance par exmeple 30 sec vrifie la pos
 * si la pos > 100 m.
 * 
 * vrification connexion internet + vrification rponse serveur (2  3 fois) avcec un thread priodique.
 */

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Timer;
import java.util.TimerTask;

import org.json.JSONException;
import org.json.JSONObject;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.provider.Settings.Secure;
import android.webkit.JavascriptInterface;
import android.webkit.WebView;

import com.gps.listener.LancerLocationListener;
import com.gps.model.ThreadUtility;
import com.gps.model.WsFunctions;
import com.gps.model.XmlUtilities;


public class MainActivity extends Activity  {
	
	private static final int timeRefreshCoord = 1000 * 60 * 1; // 1 minute laaaaa
	private static final int timeRefreshMeeting = 1000 * 60 * 1; // 3 minutes
	private static final int timeRefreshUsers = 1000 * 90 * 1; // 1:30 minutes
	private LocationManager locationManager;

    private static final long MIN_DISTANCE_CHANGE_FOR_UPDATES = 10; // 10 meters
    private static final long MIN_TIME_BW_UPDATES = (1000 * 10 * 1); // 10 secondes
	
	public static final String PREFS_NAME = "MyPrefsFile";	
    
	private  boolean geolocalisation=false;
	private  String lati_actuel="";
	private  String longi_actuel="";
	
	//----------------------------------------------
	private int bouton_afficher_carte=0;
	private int bouton_afficher_carte_ami =1;
	private int bouton_afficher_carte_meeting =2;
	
	private int bouton_map_opt = bouton_afficher_carte;
	
	
	private boolean logined_in = false;
	
	WebView webView1;
	String fileName = "/properties.xml";
	ThreadUtility thread = new ThreadUtility();
	final String inscriptionPage = "file:///android_asset/inscription.html";
	final String indexPage ="file:///android_asset/index.html";
	final String verificationPage ="file:///android_asset/verification.html";
	final String homePage ="file:///android_asset/htmlMap.html";
	final String mongroupe ="file:///android_asset/mongroupe.html";
	final String modifiernom ="file:///android_asset/modifiernom.html";
	final String addgroupe ="file:///android_asset/addgroupe.html";
	final String groups ="file:///android_asset/groups.html";
	final String demande ="file:///android_asset/demande.html";
	final String deleteami ="file:///android_asset/deleteami.html";
	final String listegroupe ="file:///android_asset/listegroupe.html";
	final String amigroupe ="file:///android_asset/amigroupe.html";
	final String detail ="file:///android_asset/detail.html";
	WsFunctions wsFunctions = new WsFunctions();
	XmlUtilities xmlUtilities = new XmlUtilities();
	LocationManager location;
	LancerLocationListener locat = new LancerLocationListener();	;
	

	@SuppressLint("SetJavaScriptEnabled")
	@Override
	protected void onCreate(Bundle savedInstanceState) {			
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		//Fix orientation application
	    super.setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
				
	    
	    //initialiser le composant webview
		webView1 = (WebView) findViewById(R.id.webView1);
				
		webView1.getSettings().setBuiltInZoomControls(true);
		webView1.setClickable(true);
		webView1.getSettings().setLightTouchEnabled(true);		
		webView1.getSettings().setJavaScriptEnabled(true);
	    
		JavaScriptInterface jsInterface =  new JavaScriptInterface(webView1);
		webView1.addJavascriptInterface(jsInterface, "Android");			

		//Renvoie vers la page : Authentification.
		webView1.post( new Runnable(){ 
	 		public void run(){  
	 		     webView1.loadUrl(indexPage);
	 	 }});			
	}


public class JavaScriptInterface {		
	
	private LocationManager locationManager = null;
	private LocationListener locationListener = null; 	
	
	public JavaScriptInterface(WebView web) {
		webView1 = web;		  
	}

	
	/**
	 * Fonction permettant d'afficher la fonctionnalit de GPS. Cette fonction assure : 
	 *  1- Rcupration barycentre
	 *  2- Rcupration amis dans le meeting
	 *  3- et les affiches
	 * @throws JSONException
	 */
	
	@SuppressLint("NewApi")
	@JavascriptInterface
	public void getMeetingUsers() {
		
		bouton_map_opt=bouton_afficher_carte_meeting;
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		 
		    		JSONObject json = new JSONObject();
		    		JSONObject jsonMeeting = new JSONObject(); 
		    		
		    		Map<String, String> myMap =  new HashMap<String, String>();
		    		myMap.put("email", session.getString("email", null));
		    		myMap.put("secretCode", session.getString("secretCode", null));	
		    	 
		    		
	    	    	// 1. recuperer les utilisateurs dans le meeting : -> mettra a jour le point central
	    	    	String enveloppe_soap = wsFunctions.callFunction("getUsersInMeeting", myMap);
		    		String result = wsFunctions.callWebService(enveloppe_soap);
		    		
		    		List<String> parameter = new ArrayList<String>();
		    		parameter.add("idUser");
		    		parameter.add("email");
		    		parameter.add("nom");
		    		parameter.add("prenom");
		    		parameter.add("phone");
		    		parameter.add("XCoord");
		    		parameter.add("YCoord");
		    		
		    		/*
		    		 * On parse l'ensemble sous format JSON afin de les afficher ct JavaScript.
		    		 */
		    		
		    		json = wsFunctions.parseSoapResponse(result, parameter, "return");
	 
		    		int length = json.get("result").toString().length();
		    		
		    		if(length>2)
		    		{
		    			//thread.loadPrintUsersOnMap(webView1, json.toString(), pos[0],pos[1]);	
		    			final String jsonData = json.toString();
		    		  
		    			//2. recuperer la position centrale du RDV
		    			String enveloppe_soap2 = wsFunctions.callFunction("getPointMeeting", myMap);
			    		String result2 = wsFunctions.callWebService(enveloppe_soap2);
			    		
			    		List<String> parameter2 = new ArrayList<String>();
			    		parameter2.add("XCoord");
			    		parameter2.add("YCoord");
			    		String ret = wsFunctions.parse(result2, "return");
			    		final String  pos[] = ret.split(";");
			    	    if(pos.length ==3)
			    		{ 
			    	    	
			    	    	final String lati_centre = pos[0];
			    			final String longi_centre = pos[1];
			    			final String nom_meeting = pos[2];
			    			
			    			//2. afficher les client. 
			    			if(bouton_map_opt==bouton_afficher_carte_meeting)
				    			webView1.post( new Runnable() { 
				 					public void run(){  
				 						webView1.loadUrl(("javascript:printUsersOnMap('"+jsonData+"','"+lati_centre+"','"+longi_centre+"')"));
				 						webView1.loadUrl("javascript:afficherInfo('<span style=\"color:blue\">Meeting actuel : "+nom_meeting+"</span>')");
							 	}});
			    			//3. afficher le chemin entre l'utilisateur et le point central 
			    			if(bouton_map_opt==bouton_afficher_carte_meeting)
			    	    	webView1.post(new Runnable() { 
			 					public void run(){  
			 						if(geolocalisation)
			 						    webView1.loadUrl("javascript:Afficher_itineraire("+lati_actuel+","+longi_actuel+","+ pos[0]+","+pos[1]+")");
			 						else
			 							webView1.loadUrl("javascript:afficherInfo('<span style=\"color:blue\">Localisation GPS en cours.</span>')");
						 	}});
			    		}
			    		else  //resultat vide 
			    		{
			    			//afficher un message
			    			webView1.post( new Runnable() { 
			 					public void run(){  
			 						webView1.loadUrl("javascript:afficherInfo('<span style=\"color:blue\">point central meeting vide</span>')");
						 	}});
			    		}
		    		}
		    		else  //resultat vide 
		    		{
		    			//afficher un message
		    			webView1.post( new Runnable() { 
		 					public void run(){  
		 						webView1.loadUrl("javascript:afficherInfo('<span style=\"color:blue\">groupe meeting vide</span>')");
					 	}});
		    		} 
		    		   		   				    	
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans getMeetingUsers')");
				 	}});	    			
				}
		     }			
		}).start();	 
		
	}
	
 
	@JavascriptInterface
	public void initialiserGoogleMap() {
		//option carte..
		bouton_map_opt = bouton_afficher_carte;
	}
	
	
	
	@JavascriptInterface
	public void onBtnInscriptionClick() {
    	webView1.post( new Runnable() { 
				public void run(){  
					webView1.loadUrl(inscriptionPage);
	 	}});		
	}
	
	/**
	 * Fonction permettant de rcuprer la liste d'amis d'un utilsateur
	 * et de les afficher sur la carte
	 *
	 */
	@JavascriptInterface
	public void onCalculateUsers() throws JSONException {
		
		bouton_map_opt=bouton_afficher_carte_ami;
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		JSONObject json = new JSONObject();		    		
		    		Map<String, String> myMap =  new HashMap<String, String>();
		    		
		    		
		    		String chaine = session.getString("email", null);
		    		
		    		myMap.put("email", session.getString("email", null));
		    		myMap.put("secretCode", session.getString("secretCode", null));	
		    		
		    		/*
		    		 * On rcupre tous les amis de lutilisateur courant avec leur coordoones
		    		 */
		    		String enveloppe_soap = wsFunctions.callFunction("getUserFriendsWithCoordoonnee", myMap);
		    		String result = wsFunctions.callWebService(enveloppe_soap);
		    		
		    		List<String> parameter = new ArrayList<String>();
		    		parameter.add("idUser");
		    		parameter.add("email");
		    		parameter.add("nom");
		    		parameter.add("prenom");
		    		parameter.add("phone");
		    		parameter.add("visibility");
		    		parameter.add("visibilityFreind");
		    		parameter.add("visibilityMeeting");
		    		parameter.add("XCoord");
		    		parameter.add("YCoord");
		    		
		    		/*
		    		 * On parse l'ensemble sous format JSON afin de les afficher ct JavaScript.
		    		 */
		    		json = wsFunctions.parseSoapResponse(result, parameter, "return");
		    		
		    		final String jsonData = json.toString();
		    		 
		    		if(bouton_map_opt==bouton_afficher_carte_ami)
		    		webView1.post( new Runnable(){public void run(){
		    			webView1.loadUrl(("javascript:printUsersOnMap('"+jsonData+"')"));
		    		}});
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans onCalculateUsers')");
				 	}});	    			
				}
		     }			
		}).start();	
	}
	
	/************  GROUPE *************
	 * @throws JSONException 
	 *********************************/
	
	
	@JavascriptInterface
	public void Addamitogroupe(String name_groupe) throws JSONException {
		thread.loadUrl(webView1, amigroupe+"?nom="+name_groupe+"");
	}
	
	@JavascriptInterface
	public void deleteAmiGroupe(String name_groupe) throws JSONException {
		thread.loadUrl(webView1, deleteami+"?nom="+name_groupe+"");
	}
	
	@JavascriptInterface
	public void update_meeting(String name_groupe) {
		thread.loadUrl(webView1, modifiernom+"?nom="+name_groupe+"");
	}
	
	@JavascriptInterface
	public void openAddGroupPage() {
		thread.loadUrl(webView1, addgroupe);
	}
	
	@JavascriptInterface
	public void openListeGroupPage() {
		thread.loadUrl(webView1, listegroupe);
	}
	
	@JavascriptInterface
	public void openDemandePage() {
		thread.loadUrl(webView1, demande);
	}
	
	
	@JavascriptInterface
	public void openRetourPage() {
		thread.loadUrl(webView1, homePage);
	}
	
	@JavascriptInterface
	public void onbtnAfficherGroupes() throws JSONException {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		Map<String, String> map = new HashMap<String, String>();
		    		
		    		//remplissage  des parametres.
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		    
		    		/*
		    		 * Appel de la mthode findmeeting
		    		 */
		    		String enveloppe_soap= wsFunctions.callFunction("findMeeting", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		
		    		List<String> parameter = new ArrayList<String>();
		    		parameter.add("idMeeting");
		    		parameter.add("nameMeeting");
		    		parameter.add("visibilityMeeting");
		    		parameter.add("XCoord");
		    		parameter.add("YCoord");
		    		   
		    		final JSONObject json = wsFunctions.parseSoapResponse(result, parameter,"return");

	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:printGroups('"+json+"')"); 
				 	}});		    		 		   				    	
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans onbtnAfficherGroupes')");
				 	}});	    			
				}
		     }			
		}).start();			
	} 
	
	
	@JavascriptInterface
	public void rendreVisiblePourMeeting(final String id_Meeting) throws JSONException {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		Map<String, String> map = new HashMap<String, String>();
		    		
		    		//remplissage  des parametres.
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		map.put("idMeeting", id_Meeting);
		    		    
		    		/*
		    		 * Appel de la mthode findmeeting
		    		 */
		    		 
		    		String enveloppe_soap= wsFunctions.callFunction("setVisibilityMeeting", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		
		    		final String ret=wsFunctions.parse(result, "return");
		    		
		    	   if(ret.equalsIgnoreCase("true"))	
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:openListeGroupPage()"); 
				 	}});
		    	   else
		    		  webView1.post( new Runnable() { 
		 					public void run(){  
		 						webView1.loadUrl("javascript:afficherInfo('erreur : rendreVisiblePourMeeting')"); 
					 	}});
		    		   
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans onbtnAfficherGroupes')");
				 	}});	    			
				}
		     }			
		}).start();			
	}
	
	@JavascriptInterface
	public void AfficherDemandeAjout() throws JSONException {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		Map<String, String> map = new HashMap<String, String>();
		    		
		    		//remplissage  des parametres.
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("demandeajoutGroupe", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		
		    		List<String> parameter = new ArrayList<String>();
		    		parameter.add("idMeeting");
		    		parameter.add("nameMeeting");
		    		
		    		/*
		    		 * Parsing du rsultat pour l'envoyer ct JavaScript
		    		 */
		    		final JSONObject json = wsFunctions.parseSoapResponse(result, parameter,"return");
		    		
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:alldemandeajout('"+json+"')");	 
				 	}});
		    				   				    	
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans AfficherDemandeAjout')");
				 	}});	    			
				}
		     }			
		}).start();			
	}


	@JavascriptInterface
	public void onbtnRemoveGroupe(final String name_meeting) {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		//remplissage  des parametres.
		    		map.put("nomgroupe",name_meeting);
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		
		    		/*
		    		 * Suppression d'un meeting
		    		 */
		    		String enveloppe_soap= wsFunctions.callFunction("removeMeeting", map);
		    		wsFunctions.callWebService(enveloppe_soap);

		    		thread.loadUrl(webView1, groups);
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans onbtnRemoveGroupe')");
				 	}});	    			
				}
		     }			
		}).start();	
	}

	@JavascriptInterface
	public void MakeVisible(final String name_meeting) {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		
		    		//remplissage  des parametres.
		    		map.put("meetingName",name_meeting);
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		
		    		/*
		    		 * Permettre  un utilisateur d'tre visible dans un groupe
		    		 */
		    		String enveloppe_soap= wsFunctions.callFunction("makeVisibleInGroupe", map);
		    		wsFunctions.callWebService(enveloppe_soap);
		    		
		    		thread.loadUrl(webView1, groups);
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans MakeVisible')");
				 	}});	    			
				}
		     }			
		}).start();			
	}
	
	@JavascriptInterface
	public String IsVisible(final String name_meeting) {
	
		final ThreadUtility th = new ThreadUtility();
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
		    public void run() {
		    	try {
		    		Map<String, String> map = new HashMap<String, String>();
		    		//remplissage  des parametres.
		    		map.put("meetingName",name_meeting);
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("isVisibleInGroupe", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		
		    		String value = wsFunctions.parse(result, "return");
		    		
		    		if(value.equals("true")) {
		    			th.setResult("oui");
		    		} else {
		    			th.setResult("non");	
		    		}
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans IsVisible')");
				 	}});	    			
				}
		     }			    
		}).start();		
		
		
		return th.getResult();
	}
	
	@JavascriptInterface
	public void onbtnAddGroupe(final String name_groupe) {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		//remplissage  des parametres.
		    		map.put("nom",name_groupe);
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("createMeeting", map);
		    		wsFunctions.callWebService(enveloppe_soap);
		    		
		    		thread.loadUrl(webView1, amigroupe+"?nom="+name_groupe+"");		    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans onbtnAddGroupe')");
				 	}});	    			
				}
		     }			
		}).start();	
	}
	
	@JavascriptInterface
	public void UpdateNameMeeting(final String anciennom, final String nouveaunom) {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		//remplissage  des parametres.
		    		map.put("nomgroupe",anciennom);
		    		map.put("nouveaunom",nouveaunom);
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("editMeeting", map);
		    		
		    		wsFunctions.callWebService(enveloppe_soap);
		    		thread.loadUrl(webView1, groups);	    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('ns UpdateNameMeeting')");
				 	}});	    			
				}
		     }			
		}).start();			
	}
	
	
	@JavascriptInterface
	public void AddToGroupe(final String email_ami, final String name_groupe) {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		
		    		map.put("meetingName",name_groupe);
		    		map.put("email1",session.getString("email", null));
		    		map.put("email2",email_ami);
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("inviteMeetingFriend", map);
		    		wsFunctions.callWebService(enveloppe_soap);
		    		thread.loadUrl(webView1, groups);
		    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans AddToGroupe')");
				 	}});	    			
				}
		     }			
		}).start();				
	}
	
	@JavascriptInterface
	public void DeleteFromGroupe(final String email_ami, final String name_groupe) {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		map.put("meetingName",name_groupe);
		    		map.put("email2",email_ami);
		    		map.put("email1",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("deleteFriendfromgroupe", map);
		    		wsFunctions.callWebService(enveloppe_soap);
		    		
		    		thread.loadUrl(webView1, groups);
		    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans DeleteFromGroupe')");
				 	}});	    			
				}
		     }			
		}).start();				
	}
	
	@JavascriptInterface
	public void AcceptToGroupe(final String meetingName) {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		map.put("meetingName",meetingName);
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("accepterajoutGroupe", map);
		    		
		    		wsFunctions.callWebService(enveloppe_soap);
		    		thread.loadUrl(webView1, groups);
		    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans AcceptToGroupe')");
				 	}});	    			
				}
		     }			
		}).start();		
	}
	
	@JavascriptInterface
	public void printGroupeFriends(final String nom_meeting) {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		//remplissage  des parametres.;
		    		map.put("nom_meeting",nom_meeting);
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("getAllFriendMeeting", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		List<String> parameter = new ArrayList<String>();
		    		parameter.add("idUser");
		    		parameter.add("nom");
		    		parameter.add("prenom");
		    		parameter.add("email");
		    		
		    		final JSONObject json = wsFunctions.parseSoapResponse(result, parameter,"return");
		    		
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:printdetails('"+json+"')");	
				 	}});		     		
		    			    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans printGroupeFriends')");
				 	}});	    			
				}
		     }			
		}).start();				
	}
	
	@JavascriptInterface
	public void printAdmin(final String nom_meeting) {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		//remplissage  des parametres.;
		    		map.put("meetingName",nom_meeting);
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("getAdmingroupe", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		List<String> parameter = new ArrayList<String>();
		    		parameter.add("idUser");
		    		parameter.add("nom");
		    		parameter.add("prenom");
		    		parameter.add("email");
		    		
		    		final JSONObject json = wsFunctions.parseSoapResponse(result, parameter,"return");

	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:printgroupeadmin('"+json+"')");
				 	}});		    			    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans printAdmin')");
				 	}});	    			
				}
		     }			
		}).start();			
	}
	
	@JavascriptInterface
	public void AfficherAmiGroupe(final String nom_meeting) {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		//remplissage  des parametres.;
		    		map.put("nom_meeting",nom_meeting);
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("getAllFriendGroup", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		List<String> parameter = new ArrayList<String>();
		    		parameter.add("idUser");
		    		parameter.add("nom");
		    		parameter.add("prenom");
		    		parameter.add("email");
		    		
		    		final JSONObject json = wsFunctions.parseSoapResponse(result, parameter,"return");
		    		
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 			    		webView1.loadUrl("javascript:afficheramigroupedetails('"+json+"')");
				 	}});			    			    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans AfficherAmiGroupe')");
				 	}});	    			
				}
		     }			
		}).start();		
	}

	
	@JavascriptInterface
	public void printMyFriends() {
		
		new Thread(new Runnable() { 
			
       	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
		    		//remplissage  des parametres.;
		    		map.put("email",session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		String enveloppe_soap= wsFunctions.callFunction("findUserFriendsByEmail", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		List<String> parameter = new ArrayList<String>();
		    		parameter.add("idUser");
		    		parameter.add("nom");
		    		parameter.add("prenom");
		    		parameter.add("email");
		    		
		    		final JSONObject json = wsFunctions.parseSoapResponse(result, parameter,"return");		    		
		    		
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:printfriends('"+json+"')");	
				 	}});					
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans printMyFriends')");
				 	}});	    			
				}
		     }			
		}).start();				
	}
	
	
	@JavascriptInterface
	public void passer_parametre(String name_meeting) {
		thread.loadUrl(webView1, mongroupe+"?nom="+name_meeting+"");
	}
	
	@JavascriptInterface
	public void onbtnDetail(String name_meeting) {
		thread.loadUrl(webView1, detail+"?nom="+name_meeting+"");
	}
	
	/********************************************
	 * Mthode pour authentifier un utilisateur			
	 ********************************************/
	
	@JavascriptInterface
	public void onbtnAuthentificationClick(final String email, final String password) {		
		
		final SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
		
		LancerLocationListener locat = new LancerLocationListener();		
		locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);	    
	    locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, MIN_TIME_BW_UPDATES, 0 ,locat);
	    
	    /*
	     * Dclaration des schedulers permettant d'automatiser les appels web service
	     */
	    final Timer time = new Timer(); // Instantiate Timer Object
		final ScheduledTask st = new ScheduledTask(); // Instantiate SheduledTask class
		 final MeetingUpdateTask meetingTask = new MeetingUpdateTask();
		final UsersUpdateTask userTask = new UsersUpdateTask();
		
		//time.schedule(st, 0, timeRefreshCoord);
	  	time.schedule(meetingTask, 0, timeRefreshMeeting); 
		
			
		//Dclaration d'un nouveau Thread pour appeler un WS.
		new Thread(new Runnable() { 
		
			Map<String, String> map = new HashMap<String, String>();
			Map<String, String> map2 = new HashMap<String, String>();
			Map<String, String> myMap = new HashMap<String, String>();
			
			List<String> parameter = new ArrayList<String>();				
			String enveloppe_soap;
			String result, value;
			
		     public void run() {
		    	try {
			    	 map.put("email",email);
			 		 map.put("password",password);
			 		 
			 		 //Gnrer le Code secret 
			 	  	 String androidId = Secure.getString(getContentResolver(), Secure.ANDROID_ID);
		    		 String secretCode = wsFunctions.generateKey(androidId);	
		    		 session.edit().putString("secretCode", secretCode).commit();
		    		 session.edit().putString("email", email).commit();
			 		 
			 		 
			 		 map.put("secretCode",session.getString("secretCode", null));			    	 
			    	 enveloppe_soap = wsFunctions.callFunction("isUserExists", map);			    	 
			    	 			    	    
			    	 result = wsFunctions.callWebService(enveloppe_soap);
			    	 value = wsFunctions.parse(result, "return");
			    	 
			    	 if(value.equals("true")) 
			    	 {	
			    		 
			 			myMap.put("email", email);
			 			myMap.put("secretCode", session.getString("secretCode", null));	
			 			
			 			/*
			 			 * Appel de la mthode WS : findUserByEmail
			 			 */
			 			enveloppe_soap = wsFunctions.callFunction("findUserByEmail", myMap);
			 			result = wsFunctions.callWebService(enveloppe_soap);
			 			
			 			/*
			 			 * Dclaration des champs qu'on souhaite avoir du rsultat
			 			 */
			 			
			 			parameter.add("activate");
			 			parameter.add("email");
			 			parameter.add("idUser");
			 			parameter.add("nom");
			 			parameter.add("phone");
			 			parameter.add("visibility");
			 			
			 			map2 = xmlUtilities.parseXmlToMap(result, parameter, "return");
						 			
			 			if(map2 != null) {			 				
			 				/*
			 				 * Si l'tat du compte est inactife alors page : Vrification
			 				 * Sinon page : Acceuil.
			 				 */
			 				
			 				if(map2.get("activate").equals("0")) {
			 					webView1.post( new Runnable(){ 
			 				 		public void run(){  
			 				 		     webView1.loadUrl(verificationPage);
			 				 	 }});			 					
			 				} else {
			 					webView1.post( new Runnable(){ 
			 				 		public void run(){  
			 				 		     webView1.loadUrl(homePage);
			 				 	 }});			 			
			 				}
			 			} else {
			 				webView1.post( new Runnable(){ 
			 					public void run(){  
			 						webView1.loadUrl("javascript:afficherInfo('User inexistant')");
	 				 		}});			 		
			 			}	
			 			
			 			//
			 			logined_in=true;
			 			time.schedule(st, 0, timeRefreshCoord);
			 			time.schedule(meetingTask, 0, timeRefreshMeeting); 
			 			time.schedule(userTask, 0, timeRefreshUsers); 
			 			
			    	 }
	    		} catch (Exception ex) {
	    			webView1.post( new Runnable(){ 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans onbtnAuthentificationClick')");
				 	}});
				}
		     }
			
		}).start();						
	}
	
	
	
	/********************************************
	 * Mthode pour inscrire un utilisateur	
	 ********************************************/
	@JavascriptInterface
	public void btnRetourPageLogin()
	{ 
		webView1.post( new Runnable(){ 
				public void run(){  
					webView1.loadUrl(indexPage);
	 		}});
		
	}
			
	
	/********************************************
	 * Mthode pour inscrire un utilisateur	
	 ********************************************/
	@JavascriptInterface
	public void byBtnSubmitInscriptionClick(final String email,final String phone,final String password,final String name,final String prenom) {
	
		System.out.println("1");
		new Thread(new Runnable() { 
//			WsFunctions wsFunctions1 = new WsFunctions();
			
		    public void run() {
		    	try {
		    		Map<String, String> map = new HashMap<String, String>();	
		    		//remplissage  des parametres.
		    		map.put("email",email);
		    		map.put("phone",phone);
		    		map.put("password",password);
		    		map.put("name",name);
		    		map.put("prenom",prenom);
		    		
		    		/*
		    		 * Gnration du Code secret
		    		 */
		    		String androidId = Secure.getString(getContentResolver(), Secure.ANDROID_ID);
		    		String secretCode = wsFunctions.generateKey(androidId);		
		    		map.put("secretCode", secretCode);
		    		
		    		//construction de l'envloppe et appel soap.
		    		String enveloppe_soap = wsFunctions.callFunction("createUser", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    	    		
		    	    String response = wsFunctions.parse(result, "return");
		    	    Map<String, String> param = new HashMap<String, String>();
		    	    param = wsFunctions.parseResponse(response);
		    	    param.put("emailValue", map.get("email"));	    
		    	  	   
		    	    thread.loadUrlByBtnSubmitInscriptionClick(webView1, param);
		    	    
		    	    if (param.get("activate").equals("1")) {	    	
		    	    	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
		    	    	session.edit().putString("email", map.get("email")).commit();
		    	    	session.edit().putString("secretCode", secretCode).commit();
		    	    	webView1.post( new Runnable(){ 
		 					public void run(){  
		 						webView1.loadUrl(verificationPage);
 				 		}});		    	    	
		    	    } else {
		    	    	webView1.post( new Runnable(){ 
		 					public void run(){  
		 						webView1.loadUrl("javascript:afficherInfo('erreur de saisie')");
 				 		}});		    	    	
		    	    }			    	
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable(){ 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans byBtnSubmitInscriptionClick')");
				 	}});	    			
				}
		     }			
		}).start();			
	}
	
	/***********************************************************
	 * Mthode pour vrifier le code saisie par un utilisateur	
	 ***********************************************************/
	
	@JavascriptInterface
	public void onBtnVerificationClick(final String code) {
		
		new Thread(new Runnable() { 

			
		    public void run() {
		    	try {
		    		
		    		Map<String, String> map = new HashMap<String, String>();
					SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
					
		    		//paramtres pour l'appel ws
		    		map.put("email", session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		map.put("generatedCode", code);
		    		
		    		String enveloppe_soap= wsFunctions.callFunction("activateAccount", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);		
		    		String response = wsFunctions.parse(result, "return");
		    		
		    		if(response.equalsIgnoreCase("true")) {
		    	    	webView1.post( new Runnable() { 
		 					public void run(){  
		 						webView1.loadUrl(homePage);
					 	}});		    			
		    		} else { 
		    	    	webView1.post( new Runnable() { 
		 					public void run(){  
		 						webView1.loadUrl("javascript:afficherInfo('Code faux')");
					 	}});		    			
		    		}		    				    	
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans onBtnVerificationClick')");
				 	}});	    			
				}
		     }			
		}).start();	
	}
	
	@JavascriptInterface
	public void ajoutFriend(final String emailAmi, final String NomAmi,final String PrenomAmi ) {
		
		new Thread(new Runnable() { 

			Map<String, String> map = new HashMap<String, String>();
			SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
			List<String> parameter = new ArrayList<String>();	
			
		    public void run() {
		    	try {
		    		String a = emailAmi;		    			    	
		    	
		    		map.put("email1", session.getString("email", null));
		    		map.put("email2", emailAmi);
		    		
		    		map.put("nom", NomAmi);
		    		map.put("prenom", PrenomAmi);		    		
		    		
		    		map.put("secretCode", session.getString("secretCode", null));
		    	
		    		String enveloppe_soap= wsFunctions.callFunction("addFriend", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		String response = wsFunctions.parse(result, "return");
		    		//parameter.add("return");
		    		//JSONObject json = new JSONObject();
		    		
		    		//json = wsFunctions.parseSoapResponse(result, parameter,"return");		
		    		
                   
		    		if(response.equalsIgnoreCase("true")) {		    		
		    			webView1.post( new Runnable() { 
		 					public void run(){  
		 						webView1.loadUrl("javascript:getAmis()");
					 	}});	
		    		}
		    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans ajoutFriend')");
				 	}});	    			
				}
		     }			
		}).start();			
	}



	@JavascriptInterface
	public void deleteFriend(final String emailAmi) {
		
		new Thread(new Runnable() { 

			Map<String, String> map = new HashMap<String, String>();
			SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
			
		    public void run() {
		    	try {
		    		String a = emailAmi;
		    		
		    		List<String> parameter = new ArrayList<String>();	
		    	
		    		map.put("email1", session.getString("email", null));
		    		map.put("email2", emailAmi);
		    		map.put("secretCode", session.getString("secretCode", null));
		    	
		    		String enveloppe_soap= wsFunctions.callFunction("RemoveUserFriend", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		String response = wsFunctions.parse(result, "return");
		    		parameter.add("return");
		    		JSONObject json = new JSONObject();
		    		
		    		json = wsFunctions.parseSoapResponse(result, parameter,"return");		    			
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans deleteFriend')");
				 	}});	    			
				}
		     }			
		}).start();	
	}


	@JavascriptInterface
	public void getAllFriends() {		
		
		new Thread(new Runnable() { 

			Map<String, String> map = new HashMap<String, String>();
			SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
			List<String> parameter = new ArrayList<String>();	
			
		    public void run() {
		    	try {	    		    	
		    		String result = null;
		    		map.put("email", session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    	
		    		String enveloppe_soap= wsFunctions.callFunction("findUserFriendsByEmail", map);
		    		result= wsFunctions.callWebService(enveloppe_soap);
		    		//String response = wsFunctions.parse(result, "return");		    		    	
			    	
			    	parameter.add("email");
			    	parameter.add("idUser");
			    	parameter.add("nom");
			    	parameter.add("prenom");
	
			    	JSONObject json = new JSONObject();
			    	json = wsFunctions.parseSoapResponse(result, parameter,"return");
			    	final String maMethode="javascript:getFriends('"+ json +"')";
				    		
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl(maMethode);
				 	}});
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans getAllFriends')");
				 	}});	    			
				}
		     }			
		}).start();	
	}

	
	@JavascriptInterface
	public void deleteFriends(final String liste_amis) {		
		
		new Thread(new Runnable() { 

			Map<String, String> map = new HashMap<String, String>();
			SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
			List<String> parameter = new ArrayList<String>();	
			
		    public void run() {
		    	try {	    		    	
		    		String result = null;
		    		map.put("email", session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    		map.put("listFriend", liste_amis);
		    	
		    		String enveloppe_soap= wsFunctions.callFunction("DeleteFriend", map);
		    		result= wsFunctions.callWebService(enveloppe_soap);
		    		String response = wsFunctions.parse(result, "return");		    		    	
			    	
		    		if(response.equals("true"))
		    		{ 	
			    	    	webView1.post( new Runnable() { 
			 					public void run(){  
			 						webView1.loadUrl("javascript:getAmis()");
						 	}});
		    		}
		    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans getAllFriends')");
				 	}});	    			
				}
		     }			
		}).start();	
	}
	
	
	@JavascriptInterface
	private Map<String, String> mesInfo() {
		
		final ThreadUtility myTh = new ThreadUtility();
		new Thread(new Runnable() { 
			
		    public void run() {
		    	try {	    		    	
		    		SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
		    		Map<String, String> map = new HashMap<String, String>();
		    		List<String> parameter = new ArrayList<String>();
		    		XmlUtilities xml = new XmlUtilities();
		    	
		    		map.put("email", session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    	
		    		String enveloppe_soap= wsFunctions.callFunction("findUserByEmail", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		String response = wsFunctions.parse(result, "return");
		    		parameter.add("email");
		    		parameter.add("nom");
		    		parameter.add("prenom");
		    		parameter.add("password");
		    		parameter.add("phone");
		    		parameter.add("secretCode");		    	
		    		
		    		map=xml.parseXmlToMap(result, parameter,"return");
		    		myTh.setMap(map);
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans mesInfo')");
				 	}});	    			
				}
		     }			
		}).start();			
		
		return myTh.getMap();
	}

	
	public class Monthread_lire_info extends Thread {
		  private String str;
		 
   		  public Map<String, String> map = new HashMap<String, String>();
  
		  
		  public Monthread_lire_info(String str) {
		    this.str = str;
		  }
		  public void run() {
		    	try {	    		    	
		    		SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
		    		List<String> parameter = new ArrayList<String>();
		    		XmlUtilities xml = new XmlUtilities();
		    	
		    		map.put("email", session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    	
		    		String enveloppe_soap= wsFunctions.callFunction("findUserByEmail", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		String response = wsFunctions.parse(result, "return");
		    		parameter.add("email");
		    		parameter.add("nom");
		    		parameter.add("prenom");
		    		parameter.add("password");
		    		parameter.add("phone");
		    		parameter.add("secretCode");		    	
		    		
		    		map=xml.parseXmlToMap(result, parameter,"return");
		    		//myTh.setMap(map);
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans mesInfo')");
				 	}});	    			
				}
		  }
		  

		  
		} // classe thread	
	
	
	
	
	
	

	@JavascriptInterface
	public void getInfoUser(){
		
		new Thread(new Runnable() { 
			
		    public void run() {
		    	try {	    		    	
		    		SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
		    		Map<String, String> map = new HashMap<String, String>();
		    		List<String> parameter = new ArrayList<String>();		    	
		    	
		    		map.put("email", session.getString("email", null));
		    		map.put("secretCode", session.getString("secretCode", null));
		    	
		    		String enveloppe_soap= wsFunctions.callFunction("findUserByEmail", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		String response = wsFunctions.parse(result, "return");
		    		parameter.add("email");
		    		parameter.add("nom");
		    		parameter.add("prenom");
		    		parameter.add("password");
		    		parameter.add("phone");
		    		parameter.add("secretCode");
		    		JSONObject json = new JSONObject();
		    	
		    		json = wsFunctions.parseSoapResponse(result, parameter,"return");
		    		
		    		final String maMethode="javascript:getMesInfo('"+ json +"')";
		    		
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl(maMethode);
				 	}});		    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans getInfoUser')");
				 	}});	    			
				}
		     }			
		}).start();			
	}

	@JavascriptInterface
	public void modificationUser(final String paramettre, final String modification){
		
		new Thread(new Runnable() { 
			
		    public void run() {
		    	try {	    		    	
		    		Map<String, String> map = new HashMap<String, String>();
		    		List<String> parameter = new ArrayList<String>();
		    		//SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);
		    		
		    		Monthread_lire_info mon_thread  = new Monthread_lire_info("");
		    		mon_thread.start();
		    		mon_thread.join();
		    		
		    		//map=mesInfo();
		    		map = mon_thread.map;
		    		
		    		if(paramettre.equalsIgnoreCase("nouveauEmail")){
		    			map.remove("email");
		    			map.put("email", modification);
		    		} else if(paramettre.equalsIgnoreCase("nouveauMDP")){
		    			map.remove("password");
		    			map.put("password", modification);
		    		} else if(paramettre.equalsIgnoreCase("nouveauTel")){
		    			map.remove("phone");
		    			map.put("phone", modification);
		    		}		    		
		    	
		    		String enveloppe_soap= wsFunctions.callFunction("editUser", map);
		    		String result= wsFunctions.callWebService(enveloppe_soap);
		    		String response = wsFunctions.parse(result, "return");    		
		    		
		    		if (response.equals("OK")==true)
		    			webView1.loadUrl("javascript:afficherInfo('<span style=\"color:#0000ee;\">Modification effectuee</span>')");
		    		else
		    			webView1.loadUrl("javascript:afficherInfo('Modification refusee')");
		    		
	    		} catch (Exception ex) {
	    	    	webView1.post( new Runnable() { 
	 					public void run(){  
	 						webView1.loadUrl("javascript:afficherInfo('erreur dans modificationUser')");
				 	}});	    			
				}
		     }			
		}).start();			
	}
	

	/* *******************************************
	 *  			Getters & Setters
	 * *******************************************
	 */
	
	public LocationManager getLocationManager() {
		return locationManager;
	}

	public void setLocationManager(LocationManager locationManager) {
		this.locationManager = locationManager;
	}

	public LocationListener getLocationListener() {
		return locationListener;
	}

	public void setLocationListener(LocationListener locationListener) {
		this.locationListener = locationListener;
	}
}
	
    private boolean haveNetworkConnection() {     	
    	ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
            NetworkInfo netInfo = cm.getActiveNetworkInfo();
            if (netInfo != null && netInfo.isConnectedOrConnecting()) {
                return true;
            }
            return false;
    }
    
    
    /* -----------------------------------------------------------------------------
     *   CLASSES pour les schedulers et rafraichissement automatique des tches. 
     *  --------------------------------------------------------------------------*/
    
    /**
     * Task permettant de rafrachir les coordonnes d'un utilisateur
     * @author rado
     *
     */
    class ScheduledTask extends TimerTask {
    	
    	public void run() {
    		
    		new Thread(new Runnable() { 
    			
           	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
    			
    		    public void run() {
    		    	try {
    		    		if(haveNetworkConnection()) {    			
    		    			
    		    			/*
    		    			 * Dfinition du systme pour obtenir les goCode X,Y
    		    			 * Ainsi que des critres pour affiner la capture
    		    			 */
    			    		locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
    			    		Criteria critere = new Criteria();
    			    		critere.setAccuracy(Criteria.ACCURACY_FINE); //precision
    			    		critere.setAltitudeRequired(false); // 
    			    		critere.setBearingRequired(false);  //direction?
    			    		critere.setCostAllowed(true);
    			    		critere.setPowerRequirement(Criteria.POWER_LOW);
    			            String provider = locationManager.getBestProvider(critere, true);   
    			   
    			            //on rcupre la meilleur location.
    			    		Location loc = locationManager.getLastKnownLocation(provider);
    			    		
    			    		//On efectue les tches si la prise a t effectue, sinon on attend la prochaine 
    			    		if(loc != null) {    			    			
    			    			Map<String,String> myMap =  new HashMap<String, String>();
    							myMap.put("email", session.getString("email", null));
    							myMap.put("secretCode", session.getString("secretCode", null));	
    							myMap.put("coord_x", Double.toString(loc.getLatitude()));	
    							myMap.put("coord_y", Double.toString(loc.getLongitude()));	
    							
    							geolocalisation=true;
    							lati_actuel= Double.toString(loc.getLatitude());
    							longi_actuel= Double.toString(loc.getLongitude());
    							
    							//On cherche les coordones du Meeting
    							String enveloppe_soap = wsFunctions.callFunction("insertCoordonnee", myMap);
    							wsFunctions.callWebService(enveloppe_soap);	
    							
    							//System.out.println("DEBUG : LOCALISATION UPDATED");
    			    		} 
    			    		else
    			    			webView1.post( new Runnable() { 
            	 					public void run(){  
            	 						webView1.loadUrl("javascript:afficherInfo(\"<span style ='color:blue'>pas de signal gps</span>\")");
            				 	}});
        		    		 
    			    		
    		    		} else {
    		    			
    		    	    	webView1.post( new Runnable() { 
        	 					public void run(){  
        	 						webView1.loadUrl("javascript:afficherInfo('Connexion Perdu')");
        				 	}});
    		    		}     		    		   				    	
    	    		} catch (Exception ex) {
    	    	    	webView1.post( new Runnable() { 
    	 					public void run(){  
    	 						webView1.loadUrl("javascript:afficherInfo('erreur dans ScheduledTask')");
    				 	}});	    			
    				}
    		     }			
    		}).start();	    		
    	} 
    }
	
    /**
     * Task permettant de rafrachir le barycentre d'un meeting
     * @author rado
     *
     */
    
	class MeetingUpdateTask extends TimerTask {
 
		
		public void run() {
    		
    		new Thread(new Runnable() { 
    			
           	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
    			
    		    public void run() {
    		    	try {
    		    		
    		    		if(bouton_map_opt==bouton_afficher_carte_meeting && webView1.getUrl().equalsIgnoreCase(homePage))
    		    		if(haveNetworkConnection() && logined_in) {
    		    			 
    		    			JSONObject json = new JSONObject();
    			    		JSONObject jsonMeeting = new JSONObject(); 
    			    		
    			    		Map<String, String> myMap =  new HashMap<String, String>();
    			    		myMap.put("email", session.getString("email", null));
    			    		myMap.put("secretCode", session.getString("secretCode", null));	
    			    	 
    			    		
			    	    	// 1. recuperer les utilisateurs dans le meeting : -> mettra a jour le point central
			    	    	String enveloppe_soap = wsFunctions.callFunction("getUsersInMeeting", myMap);
				    		String result = wsFunctions.callWebService(enveloppe_soap);
				    		
				    		List<String> parameter = new ArrayList<String>();
				    		parameter.add("idUser");
				    		parameter.add("email");
				    		parameter.add("nom");
				    		parameter.add("prenom");
				    		parameter.add("phone");
				    		parameter.add("XCoord");
				    		parameter.add("YCoord");
				    		
				    		/*
				    		 * On parse l'ensemble sous format JSON afin de les afficher ct JavaScript.
				    		 */
				    		
				    		json = wsFunctions.parseSoapResponse(result, parameter, "return");
			 
				    		int length = json.get("result").toString().length();
				    		
				    		if(length>2)
				    		{
				    			//thread.loadPrintUsersOnMap(webView1, json.toString(), pos[0],pos[1]);	
				    			final String jsonData = json.toString();
				    		  
				    			//2. recuperer la position centrale du RDV
	    		    			String enveloppe_soap2 = wsFunctions.callFunction("getPointMeeting", myMap);
	    			    		String result2 = wsFunctions.callWebService(enveloppe_soap2);
	    			    		
	    			    		List<String> parameter2 = new ArrayList<String>();
	    			    		parameter2.add("XCoord");
	    			    		parameter2.add("YCoord");
	    			    		String ret = wsFunctions.parse(result2, "return");
	    			    		final String  pos[] = ret.split(";");
	    			    	    if(pos.length ==2)
	    			    		{ 
	    			    	    	
	    			    	    	final String lati_centre = pos[0];
					    			final String longi_centre = pos[1];
					    			
					    			//2. afficher les client. 
					    			if(bouton_map_opt==bouton_afficher_carte_meeting)
						    			webView1.post( new Runnable() { 
						 					public void run(){ 
						 						webView1.loadUrl(("javascript:printUsersOnMap('"+jsonData+"','"+lati_centre+"','"+longi_centre+"','non_actualisation')"));
									 	}});
					    			//3. afficher le chemin entre l'utilisateur et le point central 
					    			if(bouton_map_opt==bouton_afficher_carte_meeting)
	    			    	    	webView1.post(new Runnable() { 
	    			 					public void run(){  
	    			 						if(geolocalisation)
	    			 						    webView1.loadUrl("javascript:Afficher_itineraire("+lati_actuel+","+longi_actuel+","+ pos[0]+","+pos[1]+",'non_actualisation')");
	    			 						else
	    			 							webView1.loadUrl("javascript:afficherInfo('<span style=\"color:blue\">Localisation GPS en cours.</span>')");
	    						 	}});
	    			    		}
	    			    		else  //resultat vide 
	    			    		{
	    			    			//afficher un message
	    			    			webView1.post( new Runnable() { 
	    			 					public void run(){  
	    			 						webView1.loadUrl("javascript:afficherInfo('<span style=\"color:blue\">point central meeting vide</span>')");
	    						 	}});
	    			    		}
				    		}
				    		else  //resultat vide 
				    		{
				    			//afficher un message
				    			webView1.post( new Runnable() { 
				 					public void run(){  
				 						webView1.loadUrl("javascript:afficherInfo('<span style=\"color:blue\">groupe meeting vide</span>')");
							 	}});
				    		} 
    	  		   	
    		    		} else {
    		    	    	webView1.post( new Runnable() { 
        	 					public void run(){  
        	 						webView1.loadUrl("javascript:afficherInfo('MeetingUpdateTask: Connexion Perdue')");
        				 	}});
    		    		}     		    		   				    	
    	    		} catch (Exception ex) {
    	    	    	webView1.post( new Runnable() { 
    	 					public void run(){  
    	 						webView1.loadUrl("javascript:afficherInfo('erreur dans MeetingUpdateTask')");
    				 	}});	    			
    				}
    		     }			
    		}).start();	    		
    	} 		
    } 
	
	/**
	 * Task permettant de rafraichir les positions des utilisateurs
	 * @author rado
	 *
	 */
	class UsersUpdateTask extends TimerTask {
		
		public void run() {
    		
    		new Thread(new Runnable() { 
    			
           	 	SharedPreferences session = getSharedPreferences(PREFS_NAME, 0);	
    			
    		    public void run() {
    		    	try {
    		    			
		    			if(haveNetworkConnection() && logined_in) 
    		    		
    		    		
    		    		{		    	
		    		    	
		    		    	JSONObject json = new JSONObject();
		    				JSONObject jsonMeeting = new JSONObject(); 
		    				
		    				Map<String, String> myMap =  new HashMap<String, String>();
		    				myMap.put("email", session.getString("email", null));
		    				myMap.put("secretCode", session.getString("secretCode", null));	
		    				
		    				/*
		    				 * on rcupre les informations sur l'utilisateur connect
		    				 */
		    				String enveloppe_soap = wsFunctions.callFunction("findUserByEmail", myMap);
		    				String result = wsFunctions.callWebService(enveloppe_soap);
		    						
		    				List<String> parameter = new ArrayList<String>();
		    				parameter.add("visibilityMeeting");
		    				parameter.add("idUser");		
		    				
		    				Map<String, String> map;
		    	
		    				/*
		    				 * on parse le rsultat
		    				 */
	    					map = xmlUtilities.parseXmlToMap(result, parameter, "return");
	    					String idUser = map.get("idUser");						
	    					
	    					/*
	    					 * Si l'utilisateur est visible dans un meeting
	    					 */
	    					if(map.isEmpty()==false && map.get("visibilityMeeting") != "") {
	    						myMap =  new HashMap<String, String>();						
	    						myMap.put("idMeeting", map.get("visibilityMeeting"));
	    						myMap.put("email", session.getString("email", null));
	    						myMap.put("secretCode", session.getString("secretCode", null));	
	    						
	    						/*
	    						 * On recherche les informations du meeting dans lequel 
	    						 * l'utilisateur est affich
	    						 */
	    						enveloppe_soap = wsFunctions.callFunction("getMeetingById ", myMap);
	    						result = wsFunctions.callWebService(enveloppe_soap);
	    						
	    						parameter = new ArrayList<String>();
	    						parameter.add("idMeeting");
	    						parameter.add("nameMeeting");
	    						parameter.add("XCoord");
	    						parameter.add("YCoord");
	    						
	    						map = xmlUtilities.parseXmlToMap(result, parameter, "return");
	    						
	    						/*
	    						 * On garde en mmorie les coordonnes des barycentres
	    						 */
	    						jsonMeeting.put("XCoord", map.get("XCoord"));
	    						jsonMeeting.put("YCoord", map.get("YCoord"));
	    						jsonMeeting.put("idMeeting", map.get("idMeeting"));
	    						
	    						myMap =  new HashMap<String, String>();
	    						myMap.put("idMeeting", map.get("idMeeting"));
	    						myMap.put("email", session.getString("email", null));
	    						myMap.put("secretCode", session.getString("secretCode", null));	
	    						enveloppe_soap = wsFunctions.callFunction("getUsersInMeeting ", myMap);
	    						result = wsFunctions.callWebService(enveloppe_soap);
	    						
	    						parameter = new ArrayList<String>();
	    						parameter.add("email");
	    						parameter.add("idUser");
	    						parameter.add("nom");
	    						parameter.add("phone");
	    						parameter.add("prenom");
	    						parameter.add("visibility");
	    						parameter.add("XCoord");
	    						parameter.add("YCoord");
	    						json = wsFunctions.parseSoapResponse(result, parameter, "return");			    			    			

	    						//Si l'utilisateur ne change pas de meeting
	    						if(session.getString("idMeeting", null).toString().equals(map.get("idMeeting"))) {	
	    							//Si barycentre chang alors update route 
	    							if( (!session.getString("XCoord", null).toString().equals(map.get("XCoord")) ||
	    		    					 !session.getString("YCoord", null).toString().equals(map.get("YCoord")))) {
	    							
		    			    			session.edit().putString("XCoord", map.get("XCoord")).commit();
		    			    			session.edit().putString("YCoord", map.get("YCoord")).commit();
		    							thread.loadPrintRoadOfMeeting(webView1, json.toString(), jsonMeeting.toString(), session.getString("email", null));
		    						} else {
		    							
		    							thread.loadUpdateMarkersOnMap(webView1, json.toString(), jsonMeeting.toString(),idUser);
	    							}
	    						//Si l'utilisateur change de meeting : On garde les coordones et on affiche tout
	    						} else {
	    			    			session.edit().putString("idMeeting", map.get("idMeeting")).commit();
	    			    			session.edit().putString("XCoord", map.get("XCoord")).commit();
	    			    			session.edit().putString("YCoord", map.get("YCoord")).commit();
	    			    			thread.loadPrintRoadOfMeeting(webView1, json.toString(), jsonMeeting.toString(), session.getString("email", null));
	    						}
	    							    						
	    						//System.out.println("DEBUG : USERS UPDATED");
	    					} else {
	     		    	    	webView1.post( new Runnable() { 
	        	 					public void run(){  
	        	 						webView1.loadUrl("javascript:afficherInfo('UsersUpdateTask : Utilisateur inconnu')");
	        				 	}});
	    					}
    		    		} else {
    		    	    	webView1.post( new Runnable() { 
        	 					public void run(){  
        	 						webView1.loadUrl("javascript:afficherInfo('UsersUpdateTask : Connexion Perdue')");
        				 	}});
    		    		}     		    		   				    	
    	    		} catch (Exception ex) {
    	    	    	webView1.post( new Runnable() { 
    	 					public void run(){  
    	 						webView1.loadUrl("javascript:afficherInfo('UsersUpdateTask : attente rseau')");
    				 	}});	    			
    				}
    		     }			
    		}).start();	    		
    	} 		
	}
	
}