package com.gps.model;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.json.JSONException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import android.os.Environment;

public class XmlUtilities {
	
	String fileName = "/properties.xml";
	
	DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();  
	DocumentBuilder builder;  
	
	public XmlUtilities() {			
	}
	
	public boolean createFile() throws FileNotFoundException, UnsupportedEncodingException {

		File file = new File(Environment.getExternalStorageDirectory(), fileName);	
		
	    if (file.mkdirs()) {
	    	System.out.println("ENTERY");
	    	PrintWriter writer = new PrintWriter(file, "UTF-8");
	 	    writer.println("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
	 	    writer.println("<parameter>");
	 	    writer.println("<secretCode></secretCode>");
	 	    writer.println("</parameter>");
	 	    writer.close();
	 	    
	 	    return true;
	    }
	    
	    return false;
	}
	
	
	public Map<String,String> parseXmlToMap(String response, List<String> parameter, String parsingValue) throws JSONException {
		
		Map<String,String> map = new HashMap<String, String>();
		
	    try  {  	    	
	        builder = factory.newDocumentBuilder();  
	        Document document = builder.parse( new InputSource( new StringReader(response) ) );  
	        document.getDocumentElement().normalize();
	        
	        NodeList nodeList = document.getElementsByTagName(parsingValue);
	        
	        for(int i=0; i<nodeList.getLength() ; i++){
	        	Node nNode = nodeList.item(i);		        
        		Element eElement = (Element) nNode;
        		
        		for(int j=0; j<parameter.size(); ++j) {	 
        			if(eElement.getElementsByTagName(parameter.get(j)).getLength() != 0) {
        				map.put(parameter.get(j), eElement.getElementsByTagName(parameter.get(j)).item(0).getTextContent());
        			}		        				        		
        		}	        				               	
	        }
	        
	    } catch (Exception e) {  
	        e.printStackTrace();  
	    }	    	    

	    return map;
	}
	
	public void setValueToXml(String path, String node, String value) throws ParserConfigurationException, SAXException, IOException {
		DocumentBuilder dBuilder = factory.newDocumentBuilder();
		File file = new File(Environment.getRootDirectory(), fileName);
		Document doc = dBuilder.parse(file);
//		if(doc.getElementsByTagName(node).getLength() != 0) {
//			System.out.println(doc.getElementsByTagName(node).getLength());
//			System.out.println("radouuuuuane");
//			System.out.println(doc.getElementsByTagName(node).item(0).getNodeValue());
//			doc.getElementsByTagName(node).item(0).getFirstChild().setTextContent(value);
//			System.out.println("radouuuuuane2222222222");
//		}
		
		NodeList employees = doc.getElementsByTagName("parameter");
        Element emp = null;
        //loop for each employee
        System.out.println(employees.getLength());
        for(int i=0; i<employees.getLength();i++){
            emp = (Element) employees.item(i);
            System.out.println("1111");
            Node name = emp.getElementsByTagName("secretCode").item(0).getFirstChild();
            System.out.println("00000");
            System.out.println(name.getTextContent());
            name.setTextContent(value);
            System.out.println("radouuuuuane2222222222");
            doc.getDocumentElement().normalize();
        }
	}

}

//
//private void recuperer_fichier_configuration()
//{
//	String fichier_config="configuration_pieton1.txt";
//	InputStream test_existance=null; 
//	try
//	{
//		test_existance= openFileInput(fichier_config);
//	}
//	catch(Exception e )
//	{
//		File MyFile = new File(fichier_config); 
//		MyFile.delete(); 
//	}
//	
//	try{
//		if(language==1)
//		{
//			reponse.post( new Runnable(){ public void run(){ reponse.setText(" debut recuperation config"); }});  
//		}
//		else
//			reponse.post( new Runnable(){ public void run(){ reponse.setText(" early recovery config"); }});  
//			
//	    String NomFichier_config = fichier_config;
//	    String ligne_version;
//	    boolean nv_version=false;
//	    int j=1;
//   
//    
//    if (test_existance!=null)
//    {
//    	String url="/~lacomme/configuration_pieton.txt";
//		String serveur="fc.isima.fr";
//		
//		////
//		String resulat_str=wget_string_http(serveur,url);
//		if(language==1)
//		{
//			reponse.post( new Runnable(){ public void run(){ reponse.setText(" recuperation config serveur fini"); }});  
//		}
//		else
//			reponse.post( new Runnable(){ public void run(){ reponse.setText("recovery config done"); }});
//		////
//		if(resulat_str==null)
//		{
//			try{
//				 InputStreamReader inputreader = new InputStreamReader(test_existance);
//			     BufferedReader buffreader = new BufferedReader(inputreader);
//			     ligne_version = buffreader.readLine();
//			     int nb_serveur=Integer.parseInt(buffreader.readLine());
//			     String serveur_test;
//			     for (j=0;j<nb_serveur;j++)
//			      {
//			    	 serveur_test=buffreader.readLine();
//			    	 String[] mot3 =serveur_test.split(":");
//			    	 HttpURLConnection connection = (HttpURLConnection) new URL("http://"+serveur_test+"/Recuperation_donnee/Recuperation_donnee?wsdl").openConnection();
//			    	 try
//				    	{
//			    		 
//				    	connection.setRequestMethod("HEAD");
//				    	int responseCode = connection.getResponseCode();
//				    	if(language==1)
//						{
//				    		reponse.post( new Runnable(){ public void run(){ reponse.setText(" serveur trouve"); }});
//						}
//				    	else
//				    		reponse.post( new Runnable(){ public void run(){ reponse.setText(" server found"); }});
//				    	if (responseCode == 405) {
//				    	  if(mot3.length>=2)
//						    {
//						    	Serveur_ws=mot3[0];
//						    	port_ws=Integer.parseInt(mot3[1]);
//						    	break;
//						    }
//				    	}
//				    	}
//			    	 catch(Exception e){
//				    		if(j==nb_serveur-1)
//				    			if(language==1)
//								{
//					    			webView1.post( new Runnable(){public void run(){
//						              webView1.loadUrl("javascript:afficher_message('"+"aucun serveur disponible"+"','info.png',12);");
//					    			}});
//								}
//				    			else
//				    			{
//				    				webView1.post( new Runnable(){public void run(){
//							              webView1.loadUrl("javascript:afficher_message('"+"no server available"+"','info.png',12);");
//						    			}});
//				    			}
//				    	}
//			      }
//			     inputreader.close();
//			         
//		    }
//		    catch(Exception e){
//		    	test_existance.close();
//		    	
//		    }
//			test_existance.close();
//			return;
//		}
//		
//		//-----------------------------------
//		//format du fichier : 4+ lignes
//		// version
//		// nb_serveur
//		//serveur:port
//		//message....
//		//-----------------------------------
//		
//		//traiter les infos
//	    String[] mot2 =resulat_str.split("\n");
//    	
//    	
//    	
//	    try{
//	      InputStreamReader inputreader = new InputStreamReader(test_existance);
//		  BufferedReader buffreader = new BufferedReader(inputreader);
//	      ligne_version = buffreader.readLine();
//	      buffreader.close();
//	      
//		      if(!ligne_version.equals(mot2[0]))
//		      {
//		    	  nv_version=true;
//		    	  try{
//		    		  /*
//		    	      PrintWriter out  = new PrintWriter(new FileWriter(NomFichier_config));
//		    	      for (int i = 0; i < mot2.length; i++)
//		    	        out.println(mot2[i]);
//		    	      out.close();*/
//		    		  OutputStreamWriter out = new OutputStreamWriter(openFileOutput(NomFichier_config, MODE_PRIVATE));
//		    		  for (int i = 0; i < mot2.length; i++)
//				    	     out.write(mot2[i]+"\r\n");
//		    		  out.close();
//		    	    }
//		    	    catch(Exception ex){
//		    	    	test_existance.close();
//		    	    }
//		      } 
//	    }
//	    catch(Exception e){
//	    	
//	    }
//	    
//	    int nb_serveur= Integer.parseInt(mot2[1]);
//	    //tester les serveurs..
//	    
//	    for(j=1;j<=nb_serveur;j++)
//	    {
//		    String[] mot3 =mot2[1+j].split(":");
//		    
//		    HttpURLConnection connection = (HttpURLConnection) new URL("http://"+mot2[1+j]+"/Recuperation_donnee/Recuperation_donnee?wsdl").openConnection();
//	    	connection.setRequestMethod("HEAD");
//	    	try
//	    	{
//	    	int responseCode = connection.getResponseCode();
//	    	if (responseCode ==405) {
//			    Serveur_ws=mot3[0];
//			    if(mot3.length>=2)
//			    	port_ws=Integer.parseInt(mot3[1]);
//			    if(mot2.length>=2)
//			    {
//			    	
//			    	 final String msg=mot2[nb_serveur+2];
//			    	 if(nv_version==true)
//			    	 {
//			    		 webView1.post( new Runnable(){public void run(){
//				              webView1.loadUrl("javascript:afficher_message('"+msg+"','info.png',12);");
//				          }});
//			    	 }
//			    	 break;
//		    	
//			    }
//	    	}
//	        }
//    	catch(Exception e){
//    		if(j==nb_serveur)
//    			if(language==1)
//				{
//	    			webView1.post( new Runnable(){public void run(){
//		              webView1.loadUrl("javascript:afficher_message('"+"aucun serveur disponible"+"','info.png',12);");
//	    			}});
//				}
//    			else
//    				webView1.post( new Runnable(){public void run(){
//			              webView1.loadUrl("javascript:afficher_message('"+"no server available"+"','info.png',12);");
//		    			}});
//    	}
//	    }
//	    
//    }
//    else
//    {
//    	String url="/~lacomme/configuration_pieton.txt";
//		String serveur="fc.isima.fr";
//		
//		////
//		String resulat_str=wget_string_http(serveur,url);
//		
//		////
//		if(resulat_str==null)
//		{
//			return;
//		}
//	
//		//traiter les infos
//	    String[] mot2 =resulat_str.split("\n");
//  
//	    try{ // ecriture du fichier
//
//	    		  OutputStreamWriter out = new OutputStreamWriter(openFileOutput(NomFichier_config,0));
//	    		  for (int i = 0; i < mot2.length; i++)
//			    	     out.write(mot2[i]+"\r\n");
//	    		  out.close();
//	    
//	    	//PrintWriter out  = new PrintWriter(new FileWriter(NomFichier_config));
//	    	
//	    	//out.close();
//	    }
//	    catch(Exception ex){
//	    }
//	     
//	    int nb_serveur= Integer.parseInt(mot2[1]);
//	    
//	    for(j=1;j<=nb_serveur;j++)
//	    {
//		    String[] mot3 =mot2[j+1].split(":");
//		    HttpURLConnection connection = (HttpURLConnection) new URL("http://"+mot2[1+j]+"/Recuperation_donnee/Recuperation_donnee?wsdl").openConnection();
//	    	connection.setRequestMethod("HEAD");
//	    	try
//	    	{
//	    	int responseCode = connection.getResponseCode();
//	    	if (responseCode ==405) {
//			    Serveur_ws=mot3[0];
//			    if(mot3.length>=2)
//			    	port_ws=Integer.parseInt(mot3[1]);
//			    if(mot2.length>=2)
//			    {
//			    	
//			    	 final String msg=mot2[nb_serveur+2];
//			    	 webView1.post( new Runnable(){public void run(){
//			              webView1.loadUrl("javascript:afficher_message('"+msg+"','info.png',12);");
//			          }});
//			    	 test_existance.close();
//			    	 return;
//			    }
//			    
//	    	}
//	    	}
//	    	catch(Exception e){
//	    		if(j==nb_serveur)
//	    			if(language==1)
//					{
//		    			webView1.post( new Runnable(){public void run(){
//			              webView1.loadUrl("javascript:afficher_message('"+"aucun serveur disponible"+"','info.png',12);");
//		    			}});
//					}
//	    			else
//	    				webView1.post( new Runnable(){public void run(){
//				              webView1.loadUrl("javascript:afficher_message('"+"no server available"+"','info.png',12);");
//			    			}});
//	    	}
//	    	
//	    }
//    	
//    	
//    	
//    }
//    test_existance.close();
//    
//	}
//	catch(Exception e){
//		
//	}
//	
//	
//}
//
